diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
index efbd496a2..37de18a58 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
@@ -24,7 +24,7 @@ public class ItemToolShovel extends ItemTool
     }
 
     @Override
-    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_SHOVEL);
     }
@@ -38,12 +38,11 @@ public class ItemToolShovel extends ItemTool
     public boolean shovelBlock(ItemStack itemstack, @Nullable Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side) {
         int blockId = world.getBlockId(blockX, blockY, blockZ);
         int blockAbove = world.getBlockId(blockX, blockY + 1, blockZ);
-        if(side != Side.BOTTOM && blockAbove == 0 && (blockId == Blocks.GRASS.id || blockId == Blocks.DIRT.id || blockId == Blocks.GRASS_RETRO.id || blockId == Blocks.FARMLAND_DIRT.id))
+        if(side != Side.BOTTOM && blockAbove == 0 && (blockId == Blocks.GRASS.id() || blockId == Blocks.DIRT.id() || blockId == Blocks.GRASS_RETRO.id() || blockId == Blocks.FARMLAND_DIRT.id()))
         {
-            Block block = Blocks.PATH_DIRT;
             world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.blocksList[blockId], EnumBlockSoundEffectType.PLACE);
             if (!world.isClientSide) {
-                world.setBlockWithNotify(blockX, blockY, blockZ, block.id);
+                world.setBlockWithNotify(blockX, blockY, blockZ, Blocks.PATH_DIRT.id());
                 itemstack.damageItem(1, entityplayer);
             }
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
index 7289f11c9..d63651dae 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
@@ -28,22 +28,22 @@ public class ItemToolSword extends Item
     }
 
     @Override
-    public float getStrVsBlock(ItemStack itemstack, Block block)
+    public float getStrVsBlock(ItemStack itemstack, Block<?> block)
     {
-        return block.id != Blocks.COBWEB.id ? 1.5F : 15F;
+        return block != Blocks.COBWEB ? 1.5F : 15F;
     }
 
     @Override
-    public boolean hitEntity(ItemStack itemstack, Mob entityliving, Mob entityliving1)
+    public boolean hitEntity(ItemStack itemstack, Mob target, Mob attacker)
     {
-        itemstack.damageItem(1, entityliving1);
+        itemstack.damageItem(1, attacker);
         return true;
     }
 
     @Override
     public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int x, int y, int z, Side side, Mob mob)
     {
-        Block block = Blocks.blocksList[i];
+        Block<?> block = Blocks.blocksList[i];
         if(block != null) {
             if(block.getHardness() > 0.0f || isSilkTouch()) {
                 itemstack.damageItem(2, mob);
@@ -57,9 +57,9 @@ public class ItemToolSword extends Item
         blockX += direction.getOffsetX();
         blockY += direction.getOffsetY();
         blockZ += direction.getOffsetZ();
-        Block b = world.getBlock(blockX, blockY, blockZ);
+        Block<?> b = world.getBlock(blockX, blockY, blockZ);
         if (b == Blocks.PUMPKIN) {
-            world.setBlockAndMetadata(blockX, blockY, blockZ, Blocks.PUMPKIN_CARVED_IDLE.id, direction.getOpposite().getId());
+            world.setBlockAndMetadata(blockX, blockY, blockZ, Blocks.PUMPKIN_CARVED_IDLE.id(), direction.getOpposite().getId());
             itemStack.damageItem(1, null);
         }
     }
@@ -71,7 +71,7 @@ public class ItemToolSword extends Item
     }
 
     @Override
-    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_SWORD);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
index c1c7ec628..e84bc21ec 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
@@ -41,9 +41,9 @@ public class ArgumentTypeBlock implements ArgumentType<BlockInput> {
         } catch (CommandSyntaxException ignored) {}
         return parser.fillSuggestions(builder, suggestionsBuilder -> {
             String remaining = suggestionsBuilder.getRemaining().toLowerCase(Locale.ROOT);
-            for (Block block : Blocks.blocksList) {
+            for (Block<?> block : Blocks.blocksList) {
                 if (block == null) continue;
-                CommandHelper.getStringToSuggest(block.namespaceID.toString(), remaining).ifPresent(suggestionsBuilder::suggest);
+                CommandHelper.getStringToSuggest(block.namespaceId().toString(), remaining).ifPresent(suggestionsBuilder::suggest);
             }
             CommandHelper.getStringToSuggest(BlockArgumentParser.AIR_BLOCK.toString(), remaining).ifPresent(suggestionsBuilder::suggest);
             suggestionsBuilder.buildFuture();
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTestFor.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTestFor.java
index 3dc79c20d..4eb2116cb 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTestFor.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTestFor.java
@@ -53,8 +53,8 @@ public class CommandTestFor implements CommandManager.CommandRegistry {
                                             IntegerCoordinates firstPos = c.getArgument("first", IntegerCoordinates.class);
                                             IntegerCoordinates secondPos = c.getArgument("second", IntegerCoordinates.class);
 
-                                            Block firstBlock = c.getSource().getWorld().getBlock(firstPos.getX(c.getSource()), firstPos.getY(c.getSource(), true), firstPos.getZ(c.getSource()));
-                                            Block secondBlock = c.getSource().getWorld().getBlock(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource()));
+                                            Block<?> firstBlock = c.getSource().getWorld().getBlock(firstPos.getX(c.getSource()), firstPos.getY(c.getSource(), true), firstPos.getZ(c.getSource()));
+                                            Block<?> secondBlock = c.getSource().getWorld().getBlock(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource()));
 
                                             if (firstBlock != secondBlock) {
                                                 c.getSource().sendTranslatableMessage("command.commands.testfor.block.failure");
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
index 549ccb6f7..281c9df23 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
@@ -18,7 +18,7 @@ import java.util.function.Consumer;
 public class BlockArgumentParser extends ArgumentParser {
     private static final SimpleCommandExceptionType INVALID_BLOCK = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.block.invalid_block"));
     public static final NamespaceID AIR_BLOCK = new NamespaceID("minecraft", "block/air");
-    private Block block;
+    private Block<?> block;
     private int metadata = 0;
     private CompoundTag tag = new CompoundTag();
 
@@ -67,9 +67,9 @@ public class BlockArgumentParser extends ArgumentParser {
             this.block = null;
             isAir = true;
         } else {
-            for (Block blockInList : Blocks.blocksList) {
+            for (Block<?> blockInList : Blocks.blocksList) {
                 if (blockInList == null) continue;
-                if (CommandHelper.matchesNamespaceId(blockInList.namespaceID, string)) {
+                if (CommandHelper.matchesNamespaceId(blockInList.namespaceId(), string)) {
                     this.block = blockInList;
                     break;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockInput.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockInput.java
index f1ef4e5ec..1a1dd7e01 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockInput.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/BlockInput.java
@@ -6,22 +6,22 @@ import org.jetbrains.annotations.Nullable;
 
 public class BlockInput {
     @Nullable
-    private final Block block;
+    private final Block<?> block;
     private final int metadata;
     private final CompoundTag tag;
 
-    public BlockInput(@Nullable Block block, int metadata, CompoundTag tag) {
+    public BlockInput(@Nullable Block<?> block, int metadata, CompoundTag tag) {
         this.block = block;
         this.metadata = metadata;
         this.tag = tag;
     }
 
-    public @Nullable Block getBlock() {
+    public @Nullable Block<?> getBlock() {
         return this.block;
     }
 
     public int getBlockId() {
-        return this.block == null ? 0 : this.block.id;
+        return this.block == null ? 0 : this.block.id();
     }
 
     public int getMetadata() {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/ClonedBlock.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/ClonedBlock.java
index 2eaae1ce7..cddff7fb4 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/ClonedBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/ClonedBlock.java
@@ -6,23 +6,23 @@ import org.jetbrains.annotations.Nullable;
 
 public class ClonedBlock {
     @Nullable
-    private final Block block;
+    private final Block<?> block;
     private final int metadata;
     @Nullable
     private final TileEntity tileEntity;
 
-    public ClonedBlock(@Nullable Block block, int metadata, @Nullable TileEntity tileEntity) {
+    public ClonedBlock(@Nullable Block<?> block, int metadata, @Nullable TileEntity tileEntity) {
         this.block = block;
         this.metadata = metadata;
         this.tileEntity = tileEntity;
     }
 
-    public @Nullable Block getBlock() {
+    public @Nullable Block<?> getBlock() {
         return this.block;
     }
 
     public int getBlockId() {
-        return this.block == null ? 0 : this.block.id;
+        return this.block == null ? 0 : this.block.id();
     }
 
     public int getMetadata() {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParameterTypes.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParameterTypes.java
index ea043a279..8b88a3ee6 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParameterTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParameterTypes.java
@@ -32,13 +32,13 @@ public class WorldFeatureParameterTypes {
         throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownCommand().createWithContext(stringReader);
     }
 
-    private static Block parseBlock(StringReader reader, WorldFeatureParser parser) throws CommandSyntaxException {
+    private static Block<?> parseBlock(StringReader reader, WorldFeatureParser parser) throws CommandSyntaxException {
         parser.setSuggestions(CommandHelper.SUGGEST_BLOCKS);
 
         int cursor = reader.getCursor();
         final String string = reader.readString();
 
-        for (Block blockInList : Blocks.blocksList) {
+        for (Block<?> blockInList : Blocks.blocksList) {
             if (blockInList == null) continue;
             if (CommandHelper.matchesKeyString(blockInList.getKey(), string)) {
                 return blockInList;
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
index 20d263128..1a4cd1151 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
@@ -30,7 +30,7 @@ public class CommandHelper {
     public static final BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> NO_SUGGESTIONS = (builder, consumer) -> builder.buildFuture();
     public static final BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> SUGGEST_BLOCKS = (builder, consumer) -> {
         String remaining = builder.getRemaining().toLowerCase(Locale.ROOT);
-        for (Block block : Blocks.blocksList) {
+        for (Block<?> block : Blocks.blocksList) {
             if (block == null) continue;
             CommandHelper.getStringToSuggest(block.getKey(), remaining).ifPresent(builder::suggest);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
index 3d49e2850..a2cf723ce 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.net.entity.entries;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityFallingBlock;
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index 04bb5881a..4c7bfb860 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -276,7 +276,7 @@ public class ContainerInventory
         aitemstack[index] = itemstack;
     }
 
-    public float getStrVsBlock(Block block)
+    public float getStrVsBlock(Block<?> block)
     {
         float f = 1.0F;
         if(mainInventory[currentItem] != null)
@@ -380,10 +380,10 @@ public class ContainerInventory
         }
     }
 
-    public boolean canHarvestBlock(Block block)
+    public boolean canHarvestBlock(Block<?> block)
     {
         if (block == null) return false;
-        if(block.blockMaterial.isAlwaysDestroyable())
+        if(block.getMaterial().isAlwaysDestroyable())
         {
             return true;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
index bae51791c..7ff5c8ea1 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
@@ -86,7 +86,7 @@ public class MenuCrafting extends MenuAbstract
     @Override
 	public boolean stillValid(Player entityplayer)
     {
-        if(world.getBlockId(x, y, z) != Blocks.WORKBENCH.id)
+        if(world.getBlockId(x, y, z) != Blocks.WORKBENCH.id())
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index da517e6ab..dc68f4736 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -6,7 +6,6 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.SlotCreative;
@@ -137,7 +136,7 @@ public class MenuInventoryCreative extends MenuInventory
 				creativeItems.add(new ItemStack(Blocks.blocksList[id]));
 				count++;
 				
-				if (id == Blocks.WOOL.id || id == Blocks.PLANKS_OAK_PAINTED.id || id == Blocks.LAMP_IDLE.id || id == Blocks.FENCE_PLANKS_OAK_PAINTED.id)
+				if (id == Blocks.WOOL.id() || id == Blocks.PLANKS_OAK_PAINTED.id() || id == Blocks.LAMP_IDLE.id() || id == Blocks.FENCE_PLANKS_OAK_PAINTED.id())
 				{
 					for (int i = 1; i < 16; i++)
 					{
@@ -145,9 +144,9 @@ public class MenuInventoryCreative extends MenuInventory
 						count++;
 					}
 				}
-				else if (id == Blocks.CHEST_PLANKS_OAK_PAINTED.id || id == Blocks.SLAB_PLANKS_PAINTED.id || id == Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id
-					  || id == Blocks.STAIRS_PLANKS_PAINTED.id || id == Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id || id == Blocks.DOOR_PLANKS_PAINTED_TOP.id
-					  || id == Blocks.TRAPDOOR_PLANKS_PAINTED.id)
+				else if (id == Blocks.CHEST_PLANKS_OAK_PAINTED.id() || id == Blocks.SLAB_PLANKS_PAINTED.id() || id == Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id()
+					  || id == Blocks.STAIRS_PLANKS_PAINTED.id() || id == Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id() || id == Blocks.DOOR_PLANKS_PAINTED_TOP.id()
+					  || id == Blocks.TRAPDOOR_PLANKS_PAINTED.id())
 				{
 					for (int i = 0x10; i < 0x100; i += 0x10)
 					{
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
index 323c03dd2..cd181212d 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
@@ -37,8 +37,8 @@ public class SlotResult extends Slot
 
 		Item item = itemStack.getItem();
 		
-		if(item.id == Blocks.WORKBENCH.id) thePlayer.addStat(Achievements.BUILD_WORKBENCH, 1);
-		if(item.id == Blocks.FURNACE_STONE_IDLE.id) thePlayer.addStat(Achievements.BUILD_FURNACE, 1);
+		if(item.id == Blocks.WORKBENCH.id()) thePlayer.addStat(Achievements.BUILD_WORKBENCH, 1);
+		if(item.id == Blocks.FURNACE_STONE_IDLE.id()) thePlayer.addStat(Achievements.BUILD_FURNACE, 1);
 		if(item.id == Items.FOOD_BREAD.id) thePlayer.addStat(Achievements.MAKE_BREAD, 1);
 		if(item.id == Items.FOOD_CAKE.id) thePlayer.addStat(Achievements.BAKE_CAKE, 1);
 		if(item.id == Items.BUCKET_ICECREAM.id) thePlayer.addStat(Achievements.CRAFT_ICECREAM, 1);
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index b4ad36886..e8fd35cdd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -55,7 +55,7 @@ public class BlocksContainer implements WorldSource {
     }
 
     @Override
-    public Block getBlock(int x, int y, int z) {
+    public @Nullable Block<?> getBlock(int x, int y, int z) {
         return Blocks.getBlock(getBlockId(x, y, z));
     }
 
@@ -101,20 +101,20 @@ public class BlocksContainer implements WorldSource {
 
     @Override
     public Material getBlockMaterial(int x, int y, int z) {
-        Block b = getBlock(x, y, z);
-        return b == null ? Material.air : b.blockMaterial;
+        Block<?> b = getBlock(x, y, z);
+        return b == null ? Material.air : b.getMaterial();
     }
 
     @Override
     public boolean isBlockOpaqueCube(int x, int y, int z) {
-        Block b = getBlock(x, y, z);
+        Block<?> b = getBlock(x, y, z);
         return b != null && b.isSolidRender();
     }
 
     @Override
     public boolean isBlockNormalCube(int x, int y, int z) {
-        Block b = getBlock(x, y, z);
-        return b != null && b.blockMaterial.isSolidBlocking() && b.renderAsNormalBlockOnCondition(this, x, y, z);
+        Block<?> b = getBlock(x, y, z);
+        return b != null && b.getMaterial().isSolidBlocking() && b.renderAsNormalBlockOnCondition(this, x, y, z);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/Dimension.java b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
index 77c53c5b7..c74e693f4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
@@ -1,10 +1,13 @@
 package net.minecraft.core.world;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Collections;
 import java.util.HashMap;
@@ -17,14 +20,14 @@ public class Dimension
 	public final Dimension homeDim;
 	public final WorldType defaultWorldType;
 	public final float worldScale;
-	public final int portalBlockId;
+	public final @Nullable Block<? extends BlockLogicPortal> portalBlock;
 	
-	public Dimension(String languageKey, Dimension homeDim, float worldScale, int portalBlockId, WorldType defaultWorldType)
+	public Dimension(String languageKey, Dimension homeDim, float worldScale, @Nullable Block<? extends BlockLogicPortal> portalBlock, WorldType defaultWorldType)
 	{
 		this.languageKey = languageKey;
 		this.homeDim = homeDim;
 		this.worldScale = worldScale;
-		this.portalBlockId = portalBlockId;
+		this.portalBlock = portalBlock;
 		this.defaultWorldType = defaultWorldType;
 	}
 	
@@ -74,9 +77,9 @@ public class Dimension
 
 	private static final Map<Integer, Dimension> dimensionList = new HashMap<>();
 
-	public static Dimension OVERWORLD;
-	public static Dimension NETHER;
-	public static Dimension PARADISE;
+	public static final Dimension OVERWORLD = new Dimension("overworld", null, 1.0f, null, WorldTypes.OVERWORLD_DEFAULT);
+	public static final Dimension NETHER = new Dimension("nether", OVERWORLD, 0.125f, Blocks.PORTAL_NETHER, WorldTypes.NETHER_DEFAULT);
+	public static final Dimension PARADISE = new Dimension("paradise", OVERWORLD, 8.0f, Blocks.PORTAL_PARADISE, WorldTypes.PARADISE_DEFAULT);
 
 	public static Map<Integer, Dimension> getDimensionList()
 	{
@@ -95,10 +98,6 @@ public class Dimension
 		dimensionList.put(id, dimension);
 	}
 	public static void init(){
-		OVERWORLD = new Dimension("overworld", null, 1.0f, -1, WorldTypes.OVERWORLD_DEFAULT);
-		NETHER = new Dimension("nether", OVERWORLD, 0.125f, Blocks.PORTAL_NETHER.id, WorldTypes.NETHER_DEFAULT);
-		PARADISE = new Dimension("paradise", OVERWORLD, 8.0f, Blocks.PORTAL_PARADISE.id, WorldTypes.PARADISE_DEFAULT);
-
 		registerDimension(0, OVERWORLD);
 		registerDimension(1, NETHER);
 		registerDimension(2, PARADISE);
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index 43fc7e8c4..efc1b3041 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -7,7 +7,6 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
@@ -171,8 +170,7 @@ public class Explosion {
 	}
 
 	protected void createFire() {
-		List<ChunkPosition> arraylist = new ArrayList<>();
-		arraylist.addAll(destroyedBlockPositions);
+        List<ChunkPosition> arraylist = new ArrayList<>(destroyedBlockPositions);
 		for (int l2 = arraylist.size() - 1; l2 >= 0; l2--) {
 			ChunkPosition chunkposition = arraylist.get(l2);
 			
@@ -181,7 +179,7 @@ public class Explosion {
 			int z1 = chunkposition.z;
 			
 			if(worldObj.getBlockId(x1, y1, z1) == 0 && Blocks.solid[worldObj.getBlockId(x1, y1 - 1, z1)] && ExplosionRNG.nextInt(3) == 0) {
-				worldObj.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id);
+				worldObj.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
 			}
 		}
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 2faa0280b..4f9258d3f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -123,7 +123,7 @@ public class ExplosionCannonball extends Explosion{
                 int i4 = worldObj.getBlockId(i3, j3 - 1, k3);
                 if(l3 == 0 && Blocks.solid[i4] && ExplosionRNG.nextInt(3) == 0)
                 {
-                    worldObj.setBlockWithNotify(i3, j3, k3, Blocks.FIRE.id);
+                    worldObj.setBlockWithNotify(i3, j3, k3, Blocks.FIRE.id());
                 }
             }
 
@@ -143,7 +143,7 @@ public class ExplosionCannonball extends Explosion{
             int x = chunkposition.x;
             int y = chunkposition.y;
             int z = chunkposition.z;
-            int i1 = worldObj.getBlockId(x, y, z);
+            Block<?> block = worldObj.getBlock(x, y, z);
             TileEntity tileEntity = worldObj.getBlockEntity(x, y, z);
             if(flag)
             {
@@ -165,16 +165,16 @@ public class ExplosionCannonball extends Explosion{
                 worldObj.spawnParticle("explode", (d + explosionX) / 2D, (d1 + explosionY) / 2D, (d2 + explosionZ) / 2D, d3, d4, d5, 0 );
                 worldObj.spawnParticle("smoke", d, d1, d2, d3, d4, d5, 0);
             }
-            if(i1 > 0 && (Blocks.blocksList[i1].id == Blocks.GLASS.id
-                    ||  Blocks.blocksList[i1].blockMaterial == Material.topSnow
-                    ||  Blocks.blocksList[i1].blockMaterial == Material.plant
-                    ||  Blocks.blocksList[i1].blockMaterial == Material.web
-                    ||  Blocks.blocksList[i1].blockMaterial == Material.decoration
-                    ||  Blocks.blocksList[i1].blockMaterial == Material.ice))
+            if(block != null && (block == Blocks.GLASS
+                    ||  block.getMaterial() == Material.topSnow
+                    ||  block.getMaterial() == Material.plant
+                    ||  block.getMaterial() == Material.web
+                    ||  block.getMaterial() == Material.decoration
+                    ||  block.getMaterial() == Material.ice))
             {
-                Blocks.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
+                block.dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
                 worldObj.setBlockWithNotify(x, y, z, 0);
-                Blocks.blocksList[i1].onBlockDestroyedByExplosion(worldObj, x, y, z);
+                block.onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
         }
 
